require_relative 'boot/bundler_patch'

module SigtermExtensions
  module Boot
    GEMFILE = Bundler.default_gemfile
    GEMFILE_LOCK = Pathname("#{GEMFILE}.lock")
    GEMFILE_NEXT_LOCK = Pathname("#{GEMFILE}_next.lock")

    autoload :GemfileNextAutoSync, 'sigterm_extensions/staging/boot/gemfile_next_auto_sync'
    autoload :Command,             'sigterm_extensions/staging/boot/command'

    class << self
      def env_next
        env_prefix + '_NEXT'
      end

      def env_previous
        env_prefix + '_PREVIOUS'
      end

      private

      def env_prefix
        Bundler.settings['boot_env_prefix'] || 'DEPENDENCIES'
      end
    end
  end

  Boot::GemfileNextAutoSync.new.setup
  Boot::Command.new.setup
end
